package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.TblDzbcOrderLogBo;
import org.dromara.system.domain.vo.TblDzbcOrderLogVo;
import org.dromara.system.domain.TblDzbcOrderLog;
import org.dromara.system.mapper.TblDzbcOrderLogMapper;
import org.dromara.system.service.ITblDzbcOrderLogService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 定制班车-订单日志Service业务层处理
 *
 * @author Lion Li
 * @date 2025-02-12
 */
@RequiredArgsConstructor
@Service
public class TblDzbcOrderLogServiceImpl implements ITblDzbcOrderLogService {

    private final TblDzbcOrderLogMapper baseMapper;

    /**
     * 查询定制班车-订单日志
     */
    @Override
    public TblDzbcOrderLogVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询定制班车-订单日志列表
     */
    @Override
    public TableDataInfo<TblDzbcOrderLogVo> queryPageList(TblDzbcOrderLogBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TblDzbcOrderLog> lqw = buildQueryWrapper(bo);
        Page<TblDzbcOrderLogVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询定制班车-订单日志列表
     */
    @Override
    public List<TblDzbcOrderLogVo> queryList(TblDzbcOrderLogBo bo) {
        LambdaQueryWrapper<TblDzbcOrderLog> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TblDzbcOrderLog> buildQueryWrapper(TblDzbcOrderLogBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TblDzbcOrderLog> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getOrderId() != null, TblDzbcOrderLog::getOrderId, bo.getOrderId());
        lqw.eq(StringUtils.isNotBlank(bo.getExt1()), TblDzbcOrderLog::getExt1, bo.getExt1());
        lqw.eq(StringUtils.isNotBlank(bo.getExt2()), TblDzbcOrderLog::getExt2, bo.getExt2());
        return lqw;
    }

    /**
     * 新增定制班车-订单日志
     */
    @Override
    public Boolean insertByBo(TblDzbcOrderLogBo bo) {
        TblDzbcOrderLog add = MapstructUtils.convert(bo, TblDzbcOrderLog.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改定制班车-订单日志
     */
    @Override
    public Boolean updateByBo(TblDzbcOrderLogBo bo) {
        TblDzbcOrderLog update = MapstructUtils.convert(bo, TblDzbcOrderLog.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TblDzbcOrderLog entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除定制班车-订单日志
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
